// Code generated by kun; DO NOT EDIT.
// github.com/RussellLuo/kun

package helloworld

import (
	"reflect"

	"github.com/RussellLuo/kun/pkg/oas2"
)

var (
	base = `swagger: "2.0"
info:
  title: "No Title"
  version: "0.0.0"
  description: "Service is used for saying hello."
  license:
    name: "MIT"
host: "example.com"
basePath: "/"
schemes:
  - "https"
consumes:
  - "application/json"
produces:
  - "application/json"
`

	paths = `
paths:
  /messages:
    post:
      description: "SayHello says hello to the given name."
      operationId: "SayHello"
      parameters:
        - name: body
          in: body
          schema:
            $ref: "#/definitions/SayHelloRequestBody"
      %s
`
)

func getResponses(schema oas2.Schema) []oas2.OASResponses {
	return []oas2.OASResponses{
		oas2.GetOASResponses(schema, "SayHello", 200, &SayHelloResponse{}),
	}
}

func getDefinitions(schema oas2.Schema) map[string]oas2.Definition {
	defs := make(map[string]oas2.Definition)

	oas2.AddDefinition(defs, "SayHelloRequestBody", reflect.ValueOf(&struct {
		Name string `json:"name"`
	}{}))
	oas2.AddResponseDefinitions(defs, schema, "SayHello", 200, (&SayHelloResponse{}).Body())

	return defs
}

func OASv2APIDoc(schema oas2.Schema) string {
	resps := getResponses(schema)
	paths := oas2.GenPaths(resps, paths)

	defs := getDefinitions(schema)
	definitions := oas2.GenDefinitions(defs)

	return base + paths + definitions
}
